// AFCYearSelectWnd.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "AFCYearSelectWnd.h"
#include "afxpriv.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(AFCDayObj,CObject,0)
AFCDayObj::AFCDayObj()
{
	bSelect = FALSE;;
	rcPosition = CRect(0,0,0,0);
	nType = TYPE_0;
	strCaption = "";
	nDay =1;
	nCurDay =1;
	nCurMonth =1;
	nCurYear =1;
	strJiaName = "";
	nCurWeek =0;
	bWeek = TRUE;
	crTextColor = RGB(0,0,0);
	crBackColor = RGB(255,255,255);
}

AFCDayObj::~AFCDayObj()
{
	
}
void AFCDayObj::Serialize(CArchive &ar)
{
	if(ar.IsStoring())
	{
	}
	else
	{
	}
}
void AFCDayObj::Draw(CDC *pDC)
{
	int nMode = pDC->SetBkMode(TRANSPARENT);
	if(!bSelect)
	{
		DrawNormal(pDC);
	}
	else
	{
		DrawSelect(pDC);
	}
	pDC->SetBkMode(nMode);
}
void AFCDayObj::DrawNormal(CDC *pDC)
{
	switch(nType)
	{
	case TYPE_0:
		{
		}
		break;
	case TYPE_1:
		{
			pDC->FillSolidRect(rcPosition,RGB(255,0,0));
			
		}
		break;
	case TYPE_2:
		{
			pDC->FillSolidRect(rcPosition,RGB(0,255,0));
			
		}
		break;
	case TYPE_3:
		{
			
		}
		break;
	case TYPE_4:
		{
			pDC->FillSolidRect(rcPosition,RGB(0,0,255));
			
		}
		break;
	case TYPE_5:
		{
			pDC->FillSolidRect(rcPosition,RGB(0,128,128));
			
		}
		break;
		
	case TYPE_6:
		{
			pDC->FillSolidRect(rcPosition,RGB(128,0,0));
			
		}
		break;
	case TYPE_7:
		{
			pDC->FillSolidRect(rcPosition,RGB(0,128,0));
			
		}
		break;
	}
	pDC->DrawText(strCaption, rcPosition, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
}
void AFCDayObj::DrawSelect(CDC *pDC)
{
	pDC->FillSolidRect(rcPosition,::GetSysColor(COLOR_HIGHLIGHT));
	COLORREF crOld = pDC->SetTextColor(RGB(255,255,255));
	pDC->DrawText(strCaption, rcPosition, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
	pDC->SetTextColor(crOld);
}
void AFCDayObj::DrawType(CDC *pDC)
{	
	pDC;
	
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
/*static CMonth monthList[] =
{
CMonth("January",31),
CMonth("February",28),
CMonth("March",31),
CMonth("April",30),
CMonth("May",31),
CMonth("June",30),
CMonth("July",31),
CMonth("August",31),
CMonth("September",30),
CMonth("October",31),
CMonth("November",30),
CMonth("December",31)
}; 
static CMonth leapList[] =
{
CMonth("January",31),
CMonth("February",29),
CMonth("March",31),
CMonth("April",30),
CMonth("May",31),
CMonth("June",30),
CMonth("July",31),
CMonth("August",31),
CMonth("September",30),
CMonth("October",31),
CMonth("November",30),
CMonth("December",31)
}; 
*/
static int DaysinMonthX[] =
{
	31,28,31,30,31,30,31,31,30,31,30,31
};
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(AFCYueObj,CObject,0)
AFCYueObj::AFCYueObj(int nYear, int nMonth, int nDate)
{
	
	if  (-1 == nYear)
        m_nYear     = CTime::GetCurrentTime().GetYear();
    else
        m_nYear     = nYear;
	
    if  (-1 == nMonth)
        m_nMonth    = CTime::GetCurrentTime().GetMonth() -1;
    else
        m_nMonth    = nMonth -1;
	
    if  (-1 == nDate)
        m_nDate    = CTime::GetCurrentTime().GetDay() -1;
    else
        m_nDate    = nDate -1;
	
    ASSERT(m_nYear >= START_YEAR);
    ASSERT(m_nMonth >= 0   && m_nMonth <= 11);
    ASSERT(m_nDate >= 0   && m_nDate <= 30);
	
	// set number of rows and columns and margin
	nRows = 8;
	nColumns = 7;
	nMargins = 4;
	nStyle = TRADITIONAL_STYLE;
	rcPosition = CRect(0,0,0,0);
	nCurDay =1;
	nCurMonth = 1;
	nCurYear =m_nYear;
	crBackColor = RGB(255,255,255);
	crTextColor = RGB(0,0,0);
	crBorder = RGB(71,71,71);
	crTitle = ::GetSysColor(COLOR_ACTIVECAPTION);
	crTitleTextColor = RGB(255,255,255);
	crCaptionColor = ::GetSysColor(COLOR_INFOBK);
}

AFCYueObj::~AFCYueObj()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
		delete m_objects.GetNext(pos);
	m_objects.RemoveAll();
}
void AFCYueObj::Serialize(CArchive &ar)
{
	if(ar.IsStoring())
	{
	}
	else
	{
	}
}
/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* AFCYueObj::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
							CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}
void AFCYueObj::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}
BOOL AFCYueObj::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}
BOOL AFCYueObj::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
	return TRUE;        // success
}
void AFCYueObj::Add(AFCDayObj* pObj)
{
	m_objects.AddTail(pObj);
	
}

void AFCYueObj::Remove(AFCDayObj* pObj)
{
	// Find and remove from document
	POSITION pos = m_objects.Find(pObj);
	if (pos != NULL)
		m_objects.RemoveAt(pos);
	
}
int AFCYueObj::GetDaysinMonth()
{
	int nDays;
	
	nDays = DaysinMonthX[m_nMonth];
	if (LeapYear() && m_nMonth == 1) nDays++;
	return (nDays);
}
BOOL AFCYueObj::LeapYear () // is the current year a leap year?
{
	if ((m_nYear % 4 == 0 && m_nYear % 100 != 0) || (m_nYear % 400 == 0))
		return (TRUE);
	else
		return (FALSE);
}

int AFCYueObj::FDOM () // obtains the day of week for the first of the current month
{
	long jday = julday (m_nMonth+1, 1, m_nYear);
	int idwk = (int) ((jday+1) % 7);
	
	return (idwk);
}

#define IGREG (15+31L*(10+12L*1582)) // Gregorian Calendar (started in October 15, 1582)
// procedure to compute day of week available
// in Numerical Recipes in C, Press et. al.
// Cambridge Press

long AFCYueObj::julday (int mm, int id, int iyyy)
{
	long jul;
	int ja, jy, jm;
	
	if (mm > 2)
	{
		jy = iyyy;
		jm = mm + 1;
	}
	else 
	{
		jy = iyyy - 1;
		jm = mm + 13;
	}
	jul = (long) (floor(365.25*jy) + floor(30.6001*jm) + id + 1720995);
	if (id + 31L*(mm+12L*iyyy) >= IGREG) 
	{
		ja = (int)(0.01f*jy);
		jul += 2-ja+(int)(0.25*ja);
	}
	return jul;
}
void AFCYueObj::ReInit()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
		delete m_objects.GetNext(pos);
	m_objects.RemoveAll();
	InitMonth();
}
void AFCYueObj::Reset()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCDayObj *pObj = (AFCDayObj *)m_objects.GetNext(pos);
		pObj->bSelect = FALSE;
	}
}
AFCDayObj *AFCYueObj::FindDay(int nY,int nM,int nD)
{
	POSITION pos1 = m_objects.GetHeadPosition();
	while (pos1 != NULL)
	{
		AFCDayObj *pObj = (AFCDayObj *)m_objects.GetNext(pos1);
		if((pObj->nCurDay == nD)&&(pObj->nCurMonth == nM)&&(pObj->nCurYear == nY))
		{
			return pObj;
		}
	}
	return NULL;
	
}
AFCDayObj* AFCYueObj::HitTest(CPoint &pt)
{
	AFCDayObj *pObjTemp;
	pObjTemp = NULL;
	BOOL bTemp;
	bTemp = FALSE;
	
	POSITION pos1 = m_objects.GetHeadPosition();
	while (pos1 != NULL)
	{
		AFCDayObj *pObj = (AFCDayObj *)m_objects.GetNext(pos1);
		if(pObj->rcPosition.PtInRect(pt))
		{
			Reset();
			pObj->bSelect = TRUE;
			nCurDay = pObj->nCurDay;
			nCurMonth = pObj->nCurMonth;
			nCurYear = pObj->nCurYear;
			bTemp = TRUE;
			pObjTemp = pObj;
		}
	}
	return pObjTemp;
}
void AFCYueObj::ChnageYear(int nChangeYea)
{
	nChangeYea;
}
void AFCYueObj::InitMonth()
{
	CRect       rClient;
    CRect       rCell;
    CRect       rStart;
    short       nIndex = 0;
	// get day associated with the first of the month
	int nFirstDayofMonth = FDOM ();
	// get number of days in the month;
	int nDays = GetDaysinMonth();
	//nRows = (nCellsNeeded - 1)/nColumns + 3;
	rClient = rcPosition;
    // compute cell height and width
	nCellHeight = (short)((rClient.Height()-2*nMargins) / nRows);
    nCellWidth  = (short)((rClient.Width()-2*nMargins) / nColumns);
	
	// anchor point (top left)
	CPoint nAnchor;
	nAnchor.x = 4;
	nAnchor.y = 4;
	
	rStart.left = rClient.left +4;
    rStart.right = rStart.left + nCellWidth;
	rStart.top = rClient.top + 4+2*nCellHeight;
    rStart.bottom = rClient.top + 3*nCellHeight;
    rCell.CopyRect(rStart);
	BOOL bDone=FALSE;
	// show the dates (days of the month)
	BOOL bWeek;
	bWeek = TRUE;
	for (int i = 1; i < nRows-1; i++)
    {
        for (int j = 0; j < nColumns; j++)
        {
            CRect   rCurSel(rCell);
			if (!bDone && ((j+1) == nFirstDayofMonth || nFirstDayofMonth == 0))
			{
				bDone = TRUE;
				rCell.OffsetRect(nCellWidth,0);
			}
			else if (bDone)
			{
				if (nIndex < nDays) 
				{
					CString szT; 
					szT.Format ("%2d",nIndex+1);
					AFCDayObj *pObj = new AFCDayObj;
					pObj->rcPosition = rCell;
					pObj->strCaption = szT;
					pObj->bSelect = FALSE;
					pObj->nType = TYPE_0;
					pObj->nCurDay = nIndex+1;
					pObj->nCurMonth = m_nMonth+1;
					pObj->nCurYear = m_nYear;
					pObj->nCurWeek = j;
					pObj->bWeek = bWeek;	
					Add(pObj);
					nIndex++;
				}
				rCell.OffsetRect(nCellWidth,0);
			}
			else
			{
				rCell.OffsetRect(nCellWidth,0);
			}
        }
		
        rStart.OffsetRect(0,nCellHeight);
        rCell.CopyRect(rStart);
		bWeek = !bWeek;
    }
	
}
void AFCYueObj::Draw(CDC *pDC)
{
    CString     Buffer;
    CRect       rClient;
    CRect       rCell;
    CRect       rStart;
    CFont       fText;
    CFont*      pfdc;	
	
    rClient = rcPosition;
	CRect rcOther;
	rcOther = rClient;	
	pDC->FillSolidRect(rcOther,crBackColor);
    // compute cell height and width
	nCellHeight = (short)((rClient.Height()-2*nMargins) / nRows);
    nCellWidth  = (short)((rClient.Width()-2*nMargins) / nColumns);
	// anchor point (top left)
	CPoint nAnchor;
	nAnchor.x = 1;
	nAnchor.y = 1;
	
	CRect rcTemp;
	rcTemp = CRect(rcPosition.left,
		rcPosition.top +1+1*nCellHeight,
		rcPosition.right,
		rcPosition.bottom);
	pDC->FillSolidRect(rcTemp,crBackColor);
	
	m_rMinus.left = rcPosition.left+nAnchor.x;
    m_rMinus.right = m_rMinus.left + nCellWidth;
	m_rMinus.top = rcPosition.top +nAnchor.y;
    m_rMinus.bottom = m_rMinus.top + nCellHeight;
	
    // increment button//ұߵİť
	m_rPlus.right = rClient.right - nAnchor.x;
    m_rPlus.left = m_rPlus.right - nCellWidth;
	m_rPlus.top = rcPosition.top +nAnchor.y;
    m_rPlus.bottom = m_rPlus.top + nCellHeight;
	
    // placeholder for current month and year
	m_rYear.CopyRect(rClient);
    m_rYear.left = rcPosition.left +nAnchor.x;
    m_rYear.right = m_rYear.right-nAnchor.x;
	m_rYear.top = rcPosition.top + nAnchor.y;
    m_rYear.bottom = m_rYear.top + nCellHeight;
	
	CFont newFont;
	HFONT hFont = NULL;
#ifdef WIN32
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
#endif
	if (hFont == NULL)
		hFont = (HFONT)GetStockObject(ANSI_VAR_FONT);
	newFont.Attach(hFont);
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	newFont.GetLogFont(&lf);
	lf.lfHeight +=lf.lfHeight/10;
	lf.lfWeight = 600;
	fText.CreateFontIndirect(&lf);
    pfdc = pDC->SelectObject(&fText);
	
	//	pDC->FillSolidRect(m_rYear,);
	pDC->FillSolidRect(m_rYear,crTitle);
	
	pDC->SetBkMode(TRANSPARENT);
    pDC->SetTextColor(crTitleTextColor);
	
    // show current month and year
	switch(m_nMonth)
	{
	case 0:
		{
			Buffer.LoadString(IDS_AFC_MONTH1);
		}
		break;
	case 1:
		{
			Buffer.LoadString(IDS_AFC_MONTH2);
		}
		break;
	case 2:
		{
			Buffer.LoadString(IDS_AFC_MONTH3);
		}
		break;
	case 3:
		{
			Buffer.LoadString(IDS_AFC_MONTH4);
		}
		break;
	case 4:
		{
			Buffer.LoadString(IDS_AFC_MONTH5);
		}
		break;
	case 5:
		{
			Buffer.LoadString(IDS_AFC_MONTH6);
		}
		break;
	case 6:
		{
			Buffer.LoadString(IDS_AFC_MONTH7);
		}
		break;
	case 7:
		{
			Buffer.LoadString(IDS_AFC_MONTH8);
		}
		break;
	case 8:
		{
			Buffer.LoadString(IDS_AFC_MONTH9);
		}
		break;
	case 9:
		{
			Buffer.LoadString(IDS_AFC_MONTH10);
		}
		break;
	case 10:
		{
			Buffer.LoadString(IDS_AFC_MONTH11);
		}
		break;
	case 11:
		{
			Buffer.LoadString(IDS_AFC_MONTH12);
		}
		break;
	}	
    pDC->DrawText(Buffer, m_rYear, DT_CENTER|DT_VCENTER|DT_SINGLELINE);//±ǩ
	
    // draw increment and decrement buttons
	rStart.CopyRect(m_rMinus); 
	rStart.right++;
	rStart.CopyRect(m_rPlus);
	rStart.right++;
	
    
    pDC->SetBkMode(OPAQUE);
	
	
	CFont newFont1;
	HFONT hFont1 = NULL;
#ifdef WIN32
	hFont1 = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
#endif
	if (hFont1 == NULL)
		hFont1 = (HFONT)GetStockObject(ANSI_VAR_FONT);
	newFont1.Attach(hFont1);
	LOGFONT lf1;
	memset(&lf1, 0, sizeof(LOGFONT));
	newFont1.GetLogFont(&lf1);
	
    pDC->SelectObject(pfdc);
    fText.DeleteObject();
    fText.CreateFontIndirect(&lf1);
    pfdc = pDC->SelectObject(&fText);
	
    // now draw the cells
	rCell.left      = rcPosition.left +nAnchor.x;
    rCell.top       = rcPosition.top +nAnchor.y + nCellHeight;
    rCell.right     = rCell.left  + nCellWidth;
    rCell.bottom    = rCell.top   + nCellHeight;
	
	// show the days of the week
	rStart.CopyRect(rCell);
	if (nStyle == TRADITIONAL_STYLE) 
	{
		pDC->MoveTo (m_rMinus.left, rStart.bottom);
		pDC->LineTo (m_rPlus.right, rStart.bottom);
	}
	BOOL bFirst;
	bFirst = TRUE;
	for (int j = 0; j < 7; j++)
	{
		if (nStyle == SIMPLE_STYLE) 
		{
			pDC->MoveTo(rCell.left,rCell.top);
			pDC->LineTo(rCell.right,rCell.top);
			pDC->LineTo(rCell.right,rCell.bottom);
			
			pDC->MoveTo(rCell.left,rCell.top);
			pDC->LineTo(rCell.left,rCell.bottom);
		}
		CRect rCurSel(rCell);
		if(j == 6)
		{
			rCurSel.right = rClient.right;
		}
		pDC->FillSolidRect(rCurSel,crCaptionColor);
		if(bFirst)
		{
			pDC->SetTextColor(RGB(255,0,0));
			bFirst = FALSE;
		}
		else
		{
			pDC->SetTextColor(crTextColor);
		}
		CString strDrawText;
		switch(j)
		{
		case 0:
			{
				strDrawText.LoadString(IDS_AFC_DAY1);
			}
			break;
		case 1:
			{
				strDrawText.LoadString(IDS_AFC_DAY2);
			}
			break;
		case 2:
			{
				strDrawText.LoadString(IDS_AFC_DAY3);
			}
			break;
		case 3:
			{
				strDrawText.LoadString(IDS_AFC_DAY4);
			}
			break;
		case 4:
			{
				strDrawText.LoadString(IDS_AFC_DAY5);
			}
			break;
		case 5:
			{
				strDrawText.LoadString(IDS_AFC_DAY6);
			}
			break;
		case 6:
			{
				strDrawText.LoadString(IDS_AFC_DAY7);
			}
			break;
		}
		pDC->DrawText(strDrawText, rCell, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
		rCell.OffsetRect(nCellWidth,0);
	}
	pDC->SelectObject(pfdc);
    
	CFont newFont2;
	HFONT hFont2 = NULL;
#ifdef WIN32
	hFont2 = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
#endif
	if (hFont2 == NULL)
		hFont2 = (HFONT)GetStockObject(ANSI_VAR_FONT);
	newFont2.Attach(hFont2);
	LOGFONT lf2;
	memset(&lf2, 0, sizeof(LOGFONT));
	newFont2.GetLogFont(&lf2);
	
    pDC->SelectObject(pfdc);
    fText.DeleteObject();
    fText.CreateFontIndirect(&lf2);
    pfdc = pDC->SelectObject(&fText);
	pDC->SetTextColor(crTextColor);
	
    POSITION pos = m_objects.GetHeadPosition();
	while(pos != NULL)
	{
		AFCDayObj *pObj = (AFCDayObj *)m_objects.GetNext(pos);
		pObj->Draw(pDC);
	}
    pDC->SelectObject(pfdc);
	pDC->SetTextColor(RGB(0,0,0));
    fText.DeleteObject();
	
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(AFCYearObj,CObject,0)
AFCYearObj::AFCYearObj(int nY,CRect rcPos)
{
	nYear = nY;
	rcPosition = rcPos;
	rcLeft = CRect(0,0,0,0);
	rcRight = CRect(0,0,0,0);
	nCurMonth =1;
	nCurDay = 1;
	nCurYear = nY;
	InitYear();
	crBackColor = RGB(255,255,255);
	crTextColor = RGB(0,0,0);
	crBorder = RGB(71,71,71);
	crTitle = ::GetSysColor(COLOR_ACTIVECAPTION);
	crTitleTextColor = RGB(255,255,255);
	crCaptionColor = ::GetSysColor(COLOR_INFOBK);
	
}
AFCYearObj::AFCYearObj()
{
	nYear = CTime::GetCurrentTime().GetYear();
	rcPosition = CRect(0,0,0,0);
	rcLeft = CRect(0,0,0,0);
	rcRight = CRect(0,0,0,0);
	nCurMonth =1;
	nCurDay = 1;
	nCurYear = nYear;
}
AFCYearObj::~AFCYearObj()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
		delete m_objects.GetNext(pos);
	m_objects.RemoveAll();
}
void AFCYearObj::Add(AFCYueObj* pObj)
{
	m_objects.AddTail(pObj);
	
}

void AFCYearObj::Remove(AFCYueObj* pObj)
{
	// Find and remove from document
	POSITION pos = m_objects.Find(pObj);
	if (pos != NULL)
		m_objects.RemoveAt(pos);
	
}
/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* AFCYearObj::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
							 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}
void AFCYearObj::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}
BOOL AFCYearObj::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}
BOOL AFCYearObj::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}
void AFCYearObj::Serialize(CArchive &ar)
{
	if(ar.IsStoring())
	{
	}
	else
	{
	}
}
void AFCYearObj::Draw(CDC *pDC)
{
	pDC->FillSolidRect(rcPosition,RGB(255,255,255));
	CRect rcTemp1;
	rcTemp1 = CRect(rcPosition.left,
		rcPosition.top,
		rcPosition.right,
		rcPosition.top+YEAR_HEIGHT);
	CFont       fText;
    CFont*      pfdc;
	
	CFont newFont;
	HFONT hFont = NULL;
#ifdef WIN32
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
#endif
	if (hFont == NULL)
		hFont = (HFONT)GetStockObject(ANSI_VAR_FONT);
	newFont.Attach(hFont);
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	newFont.GetLogFont(&lf);
	lf.lfHeight +=lf.lfHeight/10;
	lf.lfWeight = 600;
	fText.CreateFontIndirect(&lf);
    pfdc = pDC->SelectObject(&fText);
	
	pDC->FillSolidRect(rcTemp1,crBorder);
	
	rcLeft.left = rcTemp1.left+4;
	rcLeft.top = rcTemp1.top +4;
	rcLeft.right = rcTemp1.left +22;
	rcLeft.bottom = rcTemp1.bottom -4;
	
	rcRight.left = rcTemp1.right -22;
	rcRight.right = rcTemp1.right -4;
	rcRight.top = rcTemp1.top +4;
	rcRight.bottom = rcTemp1.bottom -4;
	int nMode = pDC->SetBkMode(TRANSPARENT);
	pDC->Rectangle(rcLeft);
	pDC->Rectangle(rcRight);
	pDC->DrawText("-", rcLeft, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
	pDC->DrawText("+", rcRight, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
	
	CString strTemp;
	strTemp.Format("%u",nYear);
	COLORREF crOld = pDC->SetTextColor(RGB(255,255,255));
	pDC->DrawText(strTemp, rcTemp1, DT_VCENTER|DT_CENTER|DT_SINGLELINE);
	pDC->SetTextColor(crOld);
	pDC->SetBkMode(nMode);
	POSITION pos = m_objects.GetHeadPosition();
	while(pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		pObj->Draw(pDC);
	}
	if(pfdc != NULL)
		pDC->SelectObject(pfdc);
}
void AFCYearObj::ChangeYear(int nChangeYear)
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
		delete m_objects.GetNext(pos);
	m_objects.RemoveAll();
	nYear = nChangeYear;
	nCurYear = nYear;
	InitYear();
}
void AFCYearObj::Reset()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		pObj->Reset();
	}
}
void AFCYearObj::ResetCount()
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		AFCDayObjList *pList = (AFCDayObjList *)pObj->GetObjects();
		POSITION pos1 = pList->GetHeadPosition();
		while(pos1 != NULL)
		{
			AFCDayObj *pObject1 = (AFCDayObj *)pList->GetNext(pos1);
			pObject1->nType = TYPE_0;
			pObject1->strJiaName = "";
		}
	}
}
void AFCYearObj::ChangeWeek(int nWeek,int nType)
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		AFCDayObjList *pList = (AFCDayObjList *)pObj->GetObjects();
		POSITION pos1 = pList->GetHeadPosition();
		while(pos1 != NULL)
		{
			AFCDayObj *pObject1 = (AFCDayObj *)pList->GetNext(pos1);
			if(pObject1->nCurWeek == nWeek)
			{
				pObject1->nType = nType;
			}
		}
	}
}
void AFCYearObj::ChangeDanWeek(int nWeek,int nType,BOOL bType)
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		AFCDayObjList *pList = (AFCDayObjList *)pObj->GetObjects();
		POSITION pos1 = pList->GetHeadPosition();
		while(pos1 != NULL)
		{
			AFCDayObj *pObject1 = (AFCDayObj *)pList->GetNext(pos1);
			if((pObject1->nCurWeek == nWeek) && (pObject1->bWeek == bType))
			{
				pObject1->nType = nType;
			}
		}
	}
}
void AFCYearObj::SaveData(CString str)
{
	
}
AFCDayObj *AFCYearObj::HitTest(CPoint &pt)
{
	AFCDayObj *pObjTemp;
	pObjTemp =	NULL;
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		AFCDayObj *pDayObj = (AFCDayObj *)pObj->HitTest(pt);
		if( pDayObj!= NULL)
		{
			pObjTemp = pDayObj;
			Reset();
			nCurDay = pObj->nCurDay;
			nCurMonth = pObj->nCurMonth;
			nCurYear = pObj->nCurYear;
			pDayObj->bSelect = TRUE;
		}
		
	}
	return pObjTemp;
	
}
AFCDayObj *AFCYearObj::FindDay(int nY,int nM,int nD)
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		AFCYueObj *pObj = (AFCYueObj *)m_objects.GetNext(pos);
		AFCDayObj *pDayObj = (AFCDayObj *)pObj->FindDay(nY,nM,nD);
		if( pDayObj!= NULL)
		{
			return pDayObj;
		}
	}
	return NULL;
}
void AFCYearObj::InitYear()
{
	CRect rcPos1 = rcPosition;
	rcPos1.InflateRect(-1,-1,-1,-1);
	int nRow =3;
	int nCol =4;
	int nCelWidth;
	int nCelHeight;
	nCelHeight = (rcPos1.Height()-YEAR_HEIGHT)/nRow;
	nCelWidth = rcPos1.Width()/nCol;
	CRect rcTemp;
	rcTemp.left = rcPos1.left;
	rcTemp.top = rcPos1.top+YEAR_HEIGHT;
	rcTemp.right = rcTemp.left +nCelWidth;
	rcTemp.bottom = rcTemp.top +nCelHeight;
	int nIndex =1;
	for(int i =1;i<=3;i++)
	{
		for(int j =1;j<=4;j++)
		{
			AFCYueObj *pObj = new AFCYueObj(nYear,nIndex,1);
			pObj->rcPosition = rcTemp;
			pObj->nCurDay = 1;
			pObj->nCurMonth = nIndex;
			//	pObj->SetDaysBackColor(crBackColor);
			//	pObj->SetDaysTextColor(crTextColor);
			//	pObj->SetBorderColor(crBorder);
			//	pObj->SetYearBackColor(crTitle);
			//	pObj->SetYearBarColor(crTitleTextColor);
			//		pObj->SetWeekBarColor(crCaptionColor);
			pObj->InitMonth();
			Add(pObj);
			rcTemp.OffsetRect(nCelWidth,0);
			nIndex ++;
		}
		rcTemp.left = rcPos1.left;
		rcTemp.right = rcTemp.left + nCelWidth;
		rcTemp.OffsetRect(0,nCelHeight);
	}
	
	
}
/////////////////////////////////////////////////////////////////////////////
// AFCYearSelectWnd

AFCYearSelectWnd::AFCYearSelectWnd()
{
	CRect rcClient;
	rcClient = CRect(0,0,400,400);
	//GetClientRect(rcClient);
	crBackColor = RGB(255,255,255);
	crTextColor = RGB(0,0,0);
	crBorder = RGB(71,71,71);
	crTitle = ::GetSysColor(COLOR_ACTIVECAPTION);
	crTitleTextColor = RGB(255,255,255);
	crCaptionColor = ::GetSysColor(COLOR_INFOBK);
	pObj = new AFCYearObj(2000,rcClient);
	pObj->SetDaysBackColor(crBackColor);
	pObj->SetDaysTextColor(crTextColor);
	pObj->SetBorderColor(crBorder);
	pObj->SetYearBackColor(crTitle);
	pObj->SetYearBarColor(crTitleTextColor);
	pObj->SetWeekBarColor(crCaptionColor);
	nCurYear = 1999;
	pCurDay = NULL;
}

AFCYearSelectWnd::~AFCYearSelectWnd()
{
	if(pObj != NULL)
		delete pObj;
}


BEGIN_MESSAGE_MAP(AFCYearSelectWnd, CWnd)
//{{AFX_MSG_MAP(AFCYearSelectWnd)
ON_WM_LBUTTONDOWN()
ON_WM_PAINT()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// AFCYearSelectWnd message handlers

void AFCYearSelectWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(pObj->rcLeft.PtInRect(point))
	{
		if(nCurYear-1<=START_YEAR)
		{
			nCurYear = START_YEAR+1;
		}
		else
		{
			nCurYear--;
		}
		pObj->ChangeYear(nCurYear);
		pCurDay= NULL;
		GetParent()->SendMessage(WM_YEARCHANGE);
		Invalidate(FALSE);
	}
    else if(pObj->rcRight.PtInRect(point))
	{
		nCurYear++;
		pObj->ChangeYear(nCurYear);
		pCurDay= NULL;
		GetParent()->SendMessage(WM_YEARCHANGE);
		Invalidate(FALSE);
	}
	else
	{
		
		AFCDayObj *pObjTemp = (AFCDayObj *)pObj->HitTest(point);
		CString strTemp;
		strTemp = "";
		if(pObjTemp != NULL)
		{
			pCurDay= pObjTemp;
			Invalidate(FALSE);
		}
		
	}
	CWnd::OnLButtonDown(nFlags, point);
}

void AFCYearSelectWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CMemDC pDC(&dc);
	CRect rcClient;
	GetClientRect(rcClient);
	pDC->FillSolidRect(rcClient,crBorder);
	pObj->rcPosition = rcClient;
	pObj->Draw(pDC);
	ReleaseDC(&pDC);
	// Do not call CWnd::OnPaint() for painting messages
}

BOOL AFCYearSelectWnd::OnEraseBkgnd(CDC* pDC) 
{
	pDC;
	return TRUE;
}

BOOL AFCYearSelectWnd::Create(CRect rcPos, CWnd* pParent,UINT nID)
{
	
    CString szClassName = AfxRegisterWndClass(CS_CLASSDC|CS_SAVEBITS|CS_HREDRAW|CS_VREDRAW,
		0, (HBRUSH)NULL,0);
	
    if (!CWnd::Create(szClassName,"",WS_CHILD|WS_VISIBLE|WS_BORDER,rcPos,pParent,nID))
        return FALSE;
	
	if(pObj != NULL)
		pObj->rcPosition = CRect(0,0,rcPos.Width(),rcPos.Height());
    UpdateWindow();
    return TRUE;
}

void AFCYearSelectWnd::SaveData(CString str)
{
	if(pObj != NULL)
		pObj->SaveData(str);
}
